SystemOrganization addCategory: #SeasideCallbackTest!

WAFunctionalTest subclass: #WADecoupledCallbackTest
	instanceVariableNames: 'anchors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideCallbackTest'!

!WADecoupledCallbackTest methodsFor: 'accessing' stamp: 'sas 12/8/2007 14:34'!
children

	^ anchors asArray ! !

!WADecoupledCallbackTest methodsFor: 'initialization' stamp: 'sas 12/8/2007 14:39'!
initialize
	| one two data |  
	super initialize.
	
	one := 'one'.
	two := 'two'.
	data := #(tree four).
	
	anchors := OrderedCollection new
				add: (WAAnchor new
						text: 'This should inform "one"';
						callback: [self inform: one]
						yourself);
				add: (WAAnchor new
						text: 'This should inform "two"';
						callback: [self inform: two]
						yourself);
				add: WAAnchor new;
				add: WAAnchor new;
				yourself.
	1 to: 2 do:[:i| |symbol|
		symbol := data at: i.
		(anchors at: i +2)
			callback:[self inform: symbol];
			text: 'This should inform "', symbol, '"']! !

!WADecoupledCallbackTest methodsFor: 'accessing' stamp: 'sas 12/8/2007 14:25'!
label
	^'Decoupled Callbacks'! !

!WADecoupledCallbackTest methodsFor: 'rendering' stamp: 'sas 12/8/2007 14:26'!
renderContentOn: html
	
	anchors do:[:anAnchor|
		html render: anAnchor.
		html paragraph].! !

WAComponent subclass: #WAAnchor
	instanceVariableNames: 'callback text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideCallbackTest'!

!WAAnchor methodsFor: 'accessing' stamp: 'sas 12/8/2007 14:29'!
callback
	"Answer the value of callback"

	^ callback! !

!WAAnchor methodsFor: 'accessing' stamp: 'sas 12/8/2007 14:29'!
callback: anObject
	"Set the value of callback"

	callback := anObject! !

!WAAnchor methodsFor: 'as yet unclassified' stamp: 'sas 12/8/2007 14:30'!
renderContentOn: html

	html anchor
		callback: callback;
		with: text! !

!WAAnchor methodsFor: 'accessing' stamp: 'sas 12/8/2007 14:30'!
text
	"Answer the value of text"

	^ text! !

!WAAnchor methodsFor: 'accessing' stamp: 'sas 12/8/2007 14:30'!
text: anObject
	"Set the value of text"

	text := anObject! !
